Comparing Distributions in JavaScript

Using ApexCharts with JavaScript

This Comparing Distributions example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Shared by the vanilla-js, React and Vue builds.
//
// Both series carry RAW OBSERVATIONS, one number per trip. The chart bins them,
// and every series is binned against the SAME edges, derived from their combined
// extent. That is what makes two distributions comparable: bin each to its own
// range and identical bars would sit at different values.
//
// 900 door-to-door commute times per mode, from a seeded generator so the page
// is deterministic.
var COMMUTES = (function () {
  var seed = 20260813
  function rand() {
    seed = (seed * 16807) % 2147483647
    return (seed - 1) / 2147483646
  }
  // Box-Muller into a log-normal: journey times are right-skewed, since a trip
  // can go badly wrong but cannot finish in less than no time.
  function trips(n, mu, sigma) {
    var out = []
    for (var i = 0; i < n; i++) {
      var u1 = Math.max(rand(), 1e-9)
      var u2 = rand()
      var z = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
      out.push(Math.round(Math.exp(mu + z * sigma)))
    }
    return out
  }
  return {
    // Driving is quicker on a typical day and far less predictable: a lower
    // centre, a much heavier tail.
    car: trips(900, 3.25, 0.5),
    transit: trips(900, 3.45, 0.2),
  }
})()

function median(values) {
  var sorted = values.slice().sort(function (a, b) {
    return a - b
  })
  var mid = Math.floor(sorted.length / 2)
  return sorted.length % 2 ? sorted[mid] : (sorted[mid - 1] + sorted[mid]) / 2
}

// The bad-day figure: the trip you should actually plan around.
function worstTwentieth(values) {
  var sorted = values.slice().sort(function (a, b) {
    return a - b
  })
  return sorted[Math.floor((sorted.length - 1) * 0.95)]
}

function renderStats() {
  var el = document.querySelector('#stats')
  if (!el) return
  el.innerHTML =
    'Car: typical <b>' +
    median(COMMUTES.car) +
    ' min</b>, ' +
    'bad day <b>' +
    worstTwentieth(COMMUTES.car) +
    ' min</b> &middot; ' +
    'Transit: typical <b>' +
    median(COMMUTES.transit) +
    ' min</b>, ' +
    'bad day <b>' +
    worstTwentieth(COMMUTES.transit) +
    ' min</b>'
}

// Wires the arrangement toggle to a live chart. Shared by all three builds.
function wireComparisonControls(chart) {
  var buttons = [].slice.call(document.querySelectorAll('[data-overlap]'))

  buttons.forEach(function (b) {
    b.addEventListener('click', function () {
      var overlap = b.getAttribute('data-overlap') === 'true'
      buttons.forEach(function (other) {
        other.className = other === b ? 'on' : ''
      })
      chart.updateOptions({
        plotOptions: { histogram: { overlap: overlap } },
        // The defaults that come with an overlay are ordinary defaults, so a
        // runtime switch has to carry them itself.
        fill: { opacity: overlap ? 0.65 : 0.85 },
        stroke: overlap
          ? { show: false }
          : { show: true, width: 1, colors: ['#fff'] },
      })
    })
  })

  renderStats()
}

var options = {
  series: [
    {
      name: 'Car',
      data: COMMUTES.car,
    },
    {
      name: 'Transit',
      data: COMMUTES.transit,
    },
  ],
  chart: {
    id: 'commutes',
    type: 'histogram',
    // Fixed width, not responsive: thin bars make every bar edge a hairline, so a
    // page-width nudge of a pixel or two visibly moves the whole distribution.
    width: 700,
    height: 400,
    toolbar: {
      show: false,
    },
  },
  plotOptions: {
    histogram: {
      bins: 'auto',
      // The default with more than one series. Every distribution is drawn across
      // the full bin so they lie on top of one another; set false for side-by-side
      // bars. All series share one set of bin edges either way.
      overlap: true,
    },
  },
  colors: ['#f2a43a', '#5d6d9e'],
  xaxis: {
    title: {
      text: 'Door-to-door time (minutes)',
    },
    labels: {
      formatter: function (val) {
        return Math.round(val)
      },
    },
  },
  yaxis: {
    title: {
      text: 'Trips',
    },
  },
  legend: {
    position: 'top',
    horizontalAlign: 'right',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// COMMUTES and wireComparisonControls live in the shared head script.
wireComparisonControls(chart)

Comparing Distributions in Vue

Using ApexCharts with Vue

This Comparing Distributions example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Which commute would you rather have?</h1>
      <p>
        Two samples, 900 trips each, drawn on one set of bins. Driving has the
        lower typical time, so on the averages it wins and the question looks
        settled. The shapes say otherwise: the car's distribution is wide with a
        tail that runs off to the right, while the train's is narrow and stops.
        You are choosing between a faster average and a bad day you can plan
        around. Overlaying the two is what makes that legible; side by side, you
        end up comparing bar heights instead of shapes.
      </p>

      <div class="actions">
        <button data-overlap="true" class="on">Overlaid</button>
        <button data-overlap="false">Side by side</button>
      </div>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="histogram"
            height="400"
            width="700"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="stats" id="stats"></div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

// Shared by the vanilla-js, React and Vue builds.
//
// Both series carry RAW OBSERVATIONS, one number per trip. The chart bins them,
// and every series is binned against the SAME edges, derived from their combined
// extent. That is what makes two distributions comparable: bin each to its own
// range and identical bars would sit at different values.
//
// 900 door-to-door commute times per mode, from a seeded generator so the page
// is deterministic.
var COMMUTES = (function () {
  var seed = 20260813
  function rand() {
    seed = (seed * 16807) % 2147483647
    return (seed - 1) / 2147483646
  }
  // Box-Muller into a log-normal: journey times are right-skewed, since a trip
  // can go badly wrong but cannot finish in less than no time.
  function trips(n, mu, sigma) {
    var out = []
    for (var i = 0; i < n; i++) {
      var u1 = Math.max(rand(), 1e-9)
      var u2 = rand()
      var z = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
      out.push(Math.round(Math.exp(mu + z * sigma)))
    }
    return out
  }
  return {
    // Driving is quicker on a typical day and far less predictable: a lower
    // centre, a much heavier tail.
    car: trips(900, 3.25, 0.5),
    transit: trips(900, 3.45, 0.2),
  }
})()

function median(values) {
  var sorted = values.slice().sort(function (a, b) {
    return a - b
  })
  var mid = Math.floor(sorted.length / 2)
  return sorted.length % 2 ? sorted[mid] : (sorted[mid - 1] + sorted[mid]) / 2
}

// The bad-day figure: the trip you should actually plan around.
function worstTwentieth(values) {
  var sorted = values.slice().sort(function (a, b) {
    return a - b
  })
  return sorted[Math.floor((sorted.length - 1) * 0.95)]
}

function renderStats() {
  var el = document.querySelector('#stats')
  if (!el) return
  el.innerHTML =
    'Car: typical <b>' + median(COMMUTES.car) + ' min</b>, ' +
    'bad day <b>' + worstTwentieth(COMMUTES.car) + ' min</b> &middot; ' +
    'Transit: typical <b>' + median(COMMUTES.transit) + ' min</b>, ' +
    'bad day <b>' + worstTwentieth(COMMUTES.transit) + ' min</b>'
}

// Wires the arrangement toggle to a live chart. Shared by all three builds.
function wireComparisonControls(chart) {
  var buttons = [].slice.call(document.querySelectorAll('[data-overlap]'))

  buttons.forEach(function (b) {
    b.addEventListener('click', function () {
      var overlap = b.getAttribute('data-overlap') === 'true'
      buttons.forEach(function (other) {
        other.className = other === b ? 'on' : ''
      })
      chart.updateOptions({
        plotOptions: { histogram: { overlap: overlap } },
        // The defaults that come with an overlay are ordinary defaults, so a
        // runtime switch has to carry them itself.
        fill: { opacity: overlap ? 0.65 : 0.85 },
        stroke: overlap
          ? { show: false }
          : { show: true, width: 1, colors: ['#fff'] },
      })
    })
  })

  renderStats()
}

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [{
  name: 'Car',
  data: COMMUTES.car
}, {
  name: 'Transit',
  data: COMMUTES.transit
}],
chartOptions: {
chart: {
  id: 'commutes',
  type: 'histogram',
  // Fixed width, not responsive: thin bars make every bar edge a hairline, so a
  // page-width nudge of a pixel or two visibly moves the whole distribution.
  width: 700,
  height: 400,
  toolbar: {
    show: false
  },
},
plotOptions: {
  histogram: {
    bins: 'auto',
    // The default with more than one series. Every distribution is drawn across
    // the full bin so they lie on top of one another; set false for side-by-side
    // bars. All series share one set of bin edges either way.
    overlap: true,
  },
},
colors: ['#f2a43a', '#5d6d9e'],
xaxis: {
  title: {
    text: 'Door-to-door time (minutes)'
  },
  labels: {
    formatter: function (val) {
      return Math.round(val)
    }
  }
},
yaxis: {
  title: {
    text: 'Trips'
  },
},
legend: {
  position: 'top',
  horizontalAlign: 'right',
},
},
histTimer: null,
}
},
mounted: function () {
  // The vue-apexcharts wrapper owns the render, so reach the live instance by
  // its chart.id before wiring the controls.
  var me = this
  me.histTimer = window.setInterval(function () {
    var chart = ApexCharts.getChartByID('commutes')
    if (!chart) return
    window.clearInterval(me.histTimer)
    wireComparisonControls(chart)
  }, 50)
},
beforeDestroy: function () {
  window.clearInterval(this.histTimer)
},,
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 780px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 24px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.actions {
  margin: 20px auto 12px;
  display: flex;
  flex-wrap: wrap;
  gap: 8px;
  justify-content: center;
  align-items: center;
}
.actions button {
  color: #5b6b78;
  background: #fff;
  border: 1px solid #dfe6ec;
  padding: 7px 14px;
  font-weight: 600;
  font-size: 13px;
  border-radius: 6px;
  cursor: pointer;
}
.actions button.on {
  color: #fff;
  background: #008ffb;
  border-color: #008ffb;
}
.stats {
  text-align: center;
  font-size: 13px;
  color: #5b6b78;
  margin-top: 12px;
}
.stats b {
  color: #2c3e50;
  font-variant-numeric: tabular-nums;
}
</style>

Comparing Distributions in Angular

Using ApexCharts with Angular

This Comparing Distributions example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private COMMUTES: any = (function () {
          var seed = 20260813
          function rand() {
            seed = (seed * 16807) % 2147483647
            return (seed - 1) / 2147483646
          }
          // Box-Muller into a log-normal: journey times are right-skewed, since a trip
          // can go badly wrong but cannot finish in less than no time.
          function trips(n, mu, sigma) {
            var out = []
            for (var i = 0; i < n; i++) {
              var u1 = Math.max(rand(), 1e-9)
              var u2 = rand()
              var z = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
              out.push(Math.round(Math.exp(mu + z * sigma)))
            }
            return out
          }
          return {
            // Driving is quicker on a typical day and far less predictable: a lower
            // centre, a much heavier tail.
            car: trips(900, 3.25, 0.5),
            transit: trips(900, 3.45, 0.2),
          }
        })();

  private median = (values: any): any => {
          var sorted = values.slice().sort(function (a, b) {
            return a - b
          })
          var mid = Math.floor(sorted.length / 2)
          return sorted.length % 2 ? sorted[mid] : (sorted[mid - 1] + sorted[mid]) / 2
        };

  private worstTwentieth = (values: any): any => {
          var sorted = values.slice().sort(function (a, b) {
            return a - b
          })
          return sorted[Math.floor((sorted.length - 1) * 0.95)]
        };

  private renderStats = (): any => {
          var el = document.querySelector('#stats')
          if (!el) return
          el.innerHTML =
            'Car: typical <b>' +
            this.median(this.COMMUTES.car) +
            ' min</b>, ' +
            'bad day <b>' +
            this.worstTwentieth(this.COMMUTES.car) +
            ' min</b> &middot; ' +
            'Transit: typical <b>' +
            this.median(this.COMMUTES.transit) +
            ' min</b>, ' +
            'bad day <b>' +
            this.worstTwentieth(this.COMMUTES.transit) +
            ' min</b>'
        };

  private wireComparisonControls = (chart: any): any => {
          var buttons = [].slice.call(document.querySelectorAll('[data-overlap]'))
  
          buttons.forEach(function (b) {
            b.addEventListener('click', function () {
              var overlap = b.getAttribute('data-overlap') === 'true'
              buttons.forEach(function (other) {
                other.className = other === b ? 'on' : ''
              })
              chart.updateOptions({
                plotOptions: { histogram: { overlap: overlap } },
                // The defaults that come with an overlay are ordinary defaults, so a
                // runtime switch has to carry them itself.
                fill: { opacity: overlap ? 0.65 : 0.85 },
                stroke: overlap
                  ? { show: false }
                  : { show: true, width: 1, colors: ['#fff'] },
              })
            })
          })
  
          this.renderStats()
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Car',
              data: this.COMMUTES.car,
            },
            {
              name: 'Transit',
              data: this.COMMUTES.transit,
            },
          ],
          chart: {
            id: 'commutes',
            type: 'histogram',
            // Fixed width, not responsive: thin bars make every bar edge a hairline, so a
            // page-width nudge of a pixel or two visibly moves the whole distribution.
            width: 700,
            height: 400,
            toolbar: {
              show: false,
            },
          },
          plotOptions: {
            histogram: {
              bins: 'auto',
              // The default with more than one series. Every distribution is drawn across
              // the full bin so they lie on top of one another; set false for side-by-side
              // bars. All series share one set of bin edges either way.
              overlap: true,
            },
          },
          colors: ['#f2a43a', '#5d6d9e'],
          xaxis: {
            title: {
              text: 'Door-to-door time (minutes)',
            },
            labels: {
              formatter: (val) => {
                return Math.round(val)
              },
            },
          },
          yaxis: {
            title: {
              text: 'Trips',
            },
          },
          legend: {
            position: 'top',
            horizontalAlign: 'right',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    this.wireComparisonControls(this.chart)

    function wireComparisonControls(chart) {
            var buttons = [].slice.call(document.querySelectorAll('[data-overlap]'))

            buttons.forEach(function (b) {
              b.addEventListener('click', () => {
                var overlap = b.getAttribute('data-overlap') === 'true'
                buttons.forEach(function (other) {
                  other.className = other === b ? 'on' : ''
                })
                this.chart.updateOptions({
                  plotOptions: { histogram: { overlap: overlap } },
                  // The defaults that come with an overlay are ordinary defaults, so a
                  // runtime switch has to carry them itself.
                  fill: { opacity: overlap ? 0.65 : 0.85 },
                  stroke: overlap
                    ? { show: false }
                    : { show: true, width: 1, colors: ['#fff'] },
                })
              })
            })

            this.renderStats()
          }
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Comparing Distributions in React

Using ApexCharts with React

This Comparing Distributions example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

// Shared by the vanilla-js, React and Vue builds.
//
// Both series carry RAW OBSERVATIONS, one number per trip. The chart bins them,
// and every series is binned against the SAME edges, derived from their combined
// extent. That is what makes two distributions comparable: bin each to its own
// range and identical bars would sit at different values.
//
// 900 door-to-door commute times per mode, from a seeded generator so the page
// is deterministic.
var COMMUTES = (function () {
  var seed = 20260813
  function rand() {
    seed = (seed * 16807) % 2147483647
    return (seed - 1) / 2147483646
  }
  // Box-Muller into a log-normal: journey times are right-skewed, since a trip
  // can go badly wrong but cannot finish in less than no time.
  function trips(n, mu, sigma) {
    var out = []
    for (var i = 0; i < n; i++) {
      var u1 = Math.max(rand(), 1e-9)
      var u2 = rand()
      var z = Math.sqrt(-2 * Math.log(u1)) * Math.cos(2 * Math.PI * u2)
      out.push(Math.round(Math.exp(mu + z * sigma)))
    }
    return out
  }
  return {
    // Driving is quicker on a typical day and far less predictable: a lower
    // centre, a much heavier tail.
    car: trips(900, 3.25, 0.5),
    transit: trips(900, 3.45, 0.2),
  }
})()

function median(values) {
  var sorted = values.slice().sort(function (a, b) {
    return a - b
  })
  var mid = Math.floor(sorted.length / 2)
  return sorted.length % 2 ? sorted[mid] : (sorted[mid - 1] + sorted[mid]) / 2
}

// The bad-day figure: the trip you should actually plan around.
function worstTwentieth(values) {
  var sorted = values.slice().sort(function (a, b) {
    return a - b
  })
  return sorted[Math.floor((sorted.length - 1) * 0.95)]
}

function renderStats() {
  var el = document.querySelector('#stats')
  if (!el) return
  el.innerHTML =
    'Car: typical <b>' +
    median(COMMUTES.car) +
    ' min</b>, ' +
    'bad day <b>' +
    worstTwentieth(COMMUTES.car) +
    ' min</b> &middot; ' +
    'Transit: typical <b>' +
    median(COMMUTES.transit) +
    ' min</b>, ' +
    'bad day <b>' +
    worstTwentieth(COMMUTES.transit) +
    ' min</b>'
}

// Wires the arrangement toggle to a live chart. Shared by all three builds.
function wireComparisonControls(chart) {
  var buttons = [].slice.call(document.querySelectorAll('[data-overlap]'))

  buttons.forEach(function (b) {
    b.addEventListener('click', function () {
      var overlap = b.getAttribute('data-overlap') === 'true'
      buttons.forEach(function (other) {
        other.className = other === b ? 'on' : ''
      })
      chart.updateOptions({
        plotOptions: { histogram: { overlap: overlap } },
        // The defaults that come with an overlay are ordinary defaults, so a
        // runtime switch has to carry them itself.
        fill: { opacity: overlap ? 0.65 : 0.85 },
        stroke: overlap
          ? { show: false }
          : { show: true, width: 1, colors: ['#fff'] },
      })
    })
  })

  renderStats()
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Car',
        data: COMMUTES.car,
      },
      {
        name: 'Transit',
        data: COMMUTES.transit,
      },
    ],
    options: {
      chart: {
        id: 'commutes',
        type: 'histogram',
        // Fixed width, not responsive: thin bars make every bar edge a hairline, so a
        // page-width nudge of a pixel or two visibly moves the whole distribution.
        width: 700,
        height: 400,
        toolbar: {
          show: false,
        },
      },
      plotOptions: {
        histogram: {
          bins: 'auto',
          // The default with more than one series. Every distribution is drawn across
          // the full bin so they lie on top of one another; set false for side-by-side
          // bars. All series share one set of bin edges either way.
          overlap: true,
        },
      },
      colors: ['#f2a43a', '#5d6d9e'],
      xaxis: {
        title: {
          text: 'Door-to-door time (minutes)',
        },
        labels: {
          formatter: function (val) {
            return Math.round(val)
          },
        },
      },
      yaxis: {
        title: {
          text: 'Trips',
        },
      },
      legend: {
        position: 'top',
        horizontalAlign: 'right',
      },
    },
  })

  React.useEffect(() => {
    // The react-apexcharts wrapper owns the render, so reach the live instance
    // by its chart.id before wiring the controls.
    const timer = window.setInterval(() => {
      const chart = ApexCharts.getChartByID('commutes')
      if (!chart) return
      window.clearInterval(timer)
      wireComparisonControls(chart)
    }, 50)

    return () => window.clearInterval(timer)
  }, [])

  return (
    <div>
      <div className="wrap">
        <h1>Which commute would you rather have?</h1>
        <p>
          Two samples, 900 trips each, drawn on one set of bins. Driving has the
          lower typical time, so on the averages it wins and the question looks
          settled. The shapes say otherwise: the car's distribution is wide with
          a tail that runs off to the right, while the train's is narrow and
          stops. You are choosing between a faster average and a bad day you can
          plan around. Overlaying the two is what makes that legible; side by
          side, you end up comparing bar heights instead of shapes.
        </p>

        <div className="actions">
          <button data-overlap="true" className="on">
            Overlaid
          </button>
          <button data-overlap="false">Side by side</button>
        </div>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="histogram"
              height={400}
              width={700}
            />
          </div>
        </div>

        <div className="stats" id="stats"></div>
      </div>
    </div>
  )
}

export default ApexChart